function gold = relabelComponents(gold)

[dx, dy] = size(gold);
maxNo = max(max(gold));
newIds = zeros(maxNo, 1);
currLabel = 1;
for i = 1 : dx
    for j = 1 : dy
        if gold(i, j)
            if newIds(gold(i, j)) == 0
                newIds(gold(i, j)) = currLabel;
                currLabel = currLabel + 1;
            end
        end
    end
end

for i = 1 : dx
    for j = 1 : dy
        if gold(i, j)
            gold(i, j) = newIds(gold(i, j));
        end
    end
end

end