function bnd = findContourMap(gold, connectivity)

[dx, dy] = size(gold);
bnd = zeros(dx, dy);
for i = 1 : dx
    for j = 1 : dy
        if gold(i, j)
            if i == 1 || gold(i, j) ~= gold(i - 1, j)
                bnd(i, j) = 1;
            elseif i == dx || gold(i, j) ~= gold(i + 1, j)
                bnd(i, j) = 1;
            elseif j == 1  || gold(i, j) ~= gold(i, j - 1)
                bnd(i, j) = 1;
            elseif j == dy || gold(i, j) ~= gold(i, j + 1)
                bnd(i, j) = 1;
            end
            
            if strcmp(connectivity, 'eight') == 1
                if i > 1 && j > 1 && gold(i, j) ~= gold(i - 1, j - 1)
                    bnd(i, j) = 1;
                elseif i > 1  && j < dy && gold(i, j) ~= gold(i - 1, j + 1)
                    bnd(i, j) = 1;
                elseif i < dx && j > 1  && gold(i, j) ~= gold(i + 1, j - 1)
                    bnd(i, j) = 1;
                elseif i < dx && j < dy && gold(i, j) ~= gold(i + 1, j + 1)
                    bnd(i, j) = 1;
                end
            end
        end
    end
end

end
%----------------------------------------------------------------------%
%----------------------------------------------------------------------%
%----------------------------------------------------------------------%


