function visualizeBetti(Betti0, Betti1)

lineWidth = 4; % 2
fontSize = 28; % 20

figure, hold on, 
bsize = size(Betti0, 2)-1;
plot(0:bsize, Betti0, 'r', 'LineWidth', lineWidth)
plot(0:bsize, Betti1, 'b--', 'Color', [0 0.4470 0.7410], 'LineWidth', lineWidth)
h = gca;
axis([-bsize*0.02 bsize*1.02 -1 max(max(Betti0), max(Betti1))+1])
set(h, 'FontSize', fontSize);
legend('Bileşen (0-Betti)', 'Delik (1-Betti)', 'Location', 'northeast')
%legend('Bileşen (0-Betti)', 'Delik (1-Betti)', 'Location', 'northwest')
xlabel('Filtreleme zamanı')
ylabel('Betti sayısı')

end